ACM-三维BFS之Asteroids!——hdu1240

Asteroids!

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 3161    Accepted Submission(s): 2108

Problem Description

You‘re in space.

You want to get home.

There are asteroids.

You don‘t want to hit them.

Input

Input to this problem will consist of a (non-empty) series of up to 100 data sets. Each data set will be formatted according to the following description, and there will be no blank lines separating data sets.

A single data set has 5 components:

Start line - A single line, "START N", where 1 <= N <= 10.

Slice list - A series of N slices. Each slice is an N x N matrix representing a horizontal slice through the asteroid field. Each position in the matrix will be one of two values:

‘O‘ - (the letter "oh") Empty space

‘X‘ - (upper-case) Asteroid present

Starting Position - A single line, "A B C", denoting the <A,B,C> coordinates of your craft‘s starting position. The coordinate values will be integers separated by individual spaces.

Target Position - A single line, "D E F", denoting the <D,E,F> coordinates of your target‘s position. The coordinate values will be integers separated by individual spaces.

End line - A single line, "END"

The origin of the coordinate system is <0,0,0>. Therefore, each component of each coordinate vector will be an integer between 0 and N-1, inclusive.

The first coordinate in a set indicates the column. Left column = 0.

The second coordinate in a set indicates the row. Top row = 0.

The third coordinate in a set indicates the slice. First slice = 0.

Both the Starting Position and the Target Position will be in empty space.

Output

For each data set, there will be exactly one output set, and there will be no blank lines separating output sets.

A single output set consists of a single line. If a route exists, the line will be in the format "X Y", where X is the same as N from the corresponding input data set and Y is the least number of moves necessary to get your ship from the starting position to
the target position. If there is no route from the starting position to the target position, the line will be "NO ROUTE" instead.

A move can only be in one of the six basic directions: up, down, left, right, forward, back. Phrased more precisely, a move will either increment or decrement a single component of your current position vector by 1.

Sample Input

START 1
O
0 0 0
0 0 0
END
START 3
XXX
XXX
XXX
OOO
OOO
OOO
XXX
XXX
XXX
0 0 1
2 2 1
END
START 5
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
XXXXX
XXXXX
XXXXX
XXXXX
XXXXX
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
0 0 0
4 4 4
END

Sample Output

1 0
3 4
NO ROUTE

Source

South Central USA 2001

题目:http://acm.hdu.edu.cn/showproblem.php?pid=1240

这道题就是三维广搜,当时刚做完 胜利大逃亡 这道题,感觉很类似。

于是把这道题代码拿过来改了改就交上去。

发现过不了。

经过YM提醒,发现是i,j,k问题。

输入的N*N*N的图,最慢增长的应该是 z轴的数字。

所以Z轴的应该用i来代替读入,因为三重循环的时候i,j,k中i是增长最慢的。

简单点说:就是把曾经  cin>>map[i][j][k]改为cin>>map[j][k][i]

Why?看我之前说的。

然后普普通通的BFS,0MS  A咯~

/**************************************
***************************************
*        Author:Tree                  *
*From :http://blog.csdn.net/lttree    *
* Title : Asteroids!                  *
*Source: hdu 1240                     *
* Hint  : 三维BFS                     *
***************************************
**************************************/
#include <stdio.h>
#include <string>
#include <string.h>
#include <queue>
#include <iostream>
using namespace std;
int f_x,f_y,f_z,n;
bool ispos;
struct Coor
{
    int x,y,z,step;
};
char mapp[51][51][51];
int dis[6][3]={{1,0,0},{-1,0,0},{0,1,0},{0,-1,0},{0,0,1},{0,0,-1}};
bool vis[51][51][51];

bool judge(int x,int y,int z)
{
    if(x<0 || y<0 || z<0 || x>=n || y>=n || z>=n)   return 0;
    if(vis[x][y][z]==1 || mapp[x][y][z]==‘X‘)   return 0;
    return 1;
}

int bfs(int x,int y,int z)
{
    queue <Coor> q;
    Coor pre,next;
    int i;

    pre.x=x;
    pre.y=y;
    pre.z=z;
    pre.step=0;
    vis[x][y][z]=1;
    q.push(pre);

    while(!q.empty())
    {
        pre=q.front();
        q.pop();
        if(pre.x==f_x && pre.y==f_y && pre.z==f_z)  {ispos=1;return pre.step;}
        for(i=0;i<6;++i)
        {
            next.x=pre.x+dis[i][0];
            next.y=pre.y+dis[i][1];
            next.z=pre.z+dis[i][2];
            if(judge(next.x,next.y,next.z))
            {
                next.step=pre.step+1;
                vis[next.x][next.y][next.z]=1;
                q.push(next);
            }
        }
    }
    return -1;
}

int main()
{
    string str;
    int i,j,k,rout;
    int s_x,s_y,s_z;
    while(cin>>str>>n)
    {
        for(i=0;i<n;++i)
            for(j=0;j<n;++j)
            {
                // 把回车忽略掉
                scanf("%*");
                for(k=0;k<n;++k)
                    scanf("%c",&mapp[j][k][i]);
            }

        scanf("%d%d%d%d%d%d",&s_x,&s_y,&s_z,&f_x,&f_y,&f_z);
        cin>>str;

        memset(vis,0,sizeof(vis));
        ispos=0;
        rout=bfs(s_x,s_y,s_z);
        if(ispos)   printf("%d %d\n",n,rout);
        else    printf("NO ROUTE\n");
    }
    return 0;
}
时间: 2024-10-29 21:32:04

ACM-三维BFS之Asteroids!——hdu1240的相关文章

[ACM] hdu 1253 胜利大逃亡 (三维BFS)

胜利大逃亡 Problem Description Ignatius被魔王抓走了,有一天魔王出差去了,这可是Ignatius逃亡的好机会. 魔王住在一个城堡里,城堡是一个A*B*C的立方体,可以被表示成A个B*C的矩阵,刚开始Ignatius被关在(0,0,0)的位置,离开城堡的门在(A-1,B-1,C-1)的位置,现在知道魔王将在T分钟后回到城堡,Ignatius每分钟能从一个坐标走到相邻的六个坐标中的其中一个.现在给你城堡的地图,请你计算出Ignatius能否在魔王回来前离开城堡(只要走到出

hdu 1240:Asteroids!(三维BFS搜索)

Asteroids! Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 3159    Accepted Submission(s): 2106 Problem Description You're in space.You want to get home.There are asteroids.You don't want to hit

HDU 1240——Asteroids!(三维BFS)POJ 2225——Asteroids

普通的三维广搜,需要注意的是输入:列,行,层 #include<iostream> #include<cstdio> #include<cstring> #include<queue> #include<algorithm> #define M 11 using namespace std; int dir[6][3]={{0,1,0},{0,-1,0},{1,0,0},{-1,0,0},{0,0,1},{0,0,-1}};//6个方向 int

HDU 2225 Asteroids!(三维BFS)

Asteroids! Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Description You're in space. You want to get home. There are asteroids. You don't want to hit them. Input Input to this problem will consist of a (non-empty) seri

HDU 1240 (简单三维广搜) Asteroids!

给出一个三维的迷宫以及起点和终点,求能否到大终点,若果能输出最短步数 三维的问题无非就是变成了6个搜索方向 最后强调一下xyz的顺序,从输入数据来看,读入的顺序是map[z][x][y] 总之,这是很基础的一道题 1 //#define LOCAL 2 #include <iostream> 3 #include <cstdio> 4 #include <cstring> 5 #include <queue> 6 #include <algorithm

POJ - 2251 Dungeon Master(三维BFS)

题目链接:http://poj.org/problem?id=2251 题意:三维BFS. 题解:大水题,只不过多加了两个方向 1 //poj2251 2 #include <queue> 3 #include <cstring> 4 #include <iostream> 5 #include <algorithm> 6 using namespace std; 7 int sx,sy,sz,ex,ey,ez,L,R,C; 8 const int INF=

hdu 1885 Key Task (三维bfs)

题目 之前比赛的一个题, 当时是崔老师做的,今天我自己做了一下.... 还要注意用bfs的时候  有时候并不是最先到达的就是答案,比如HDU 3442 这道题是要求最小的消耗血量伤害,但是并不是最先到达目标点的路径 就是最小的伤害,因为每一个点的伤害是 不一样的, 这种情况要用优先队列优化, 对伤害优化. 题意:*开始, X出口, b, y, r, g 代表钥匙,分别可以开B, Y, R, G颜色的门, 钥匙可以多次使用.问最短的步骤. 思路:vis[][][]数组开三维,第三维记录状态 是否拿

POJ 2251 Dungeon Master --- 三维BFS(用BFS求最短路)

POJ 2251 题目大意: 给出一三维空间的地牢,要求求出由字符'S'到字符'E'的最短路径,移动方向可以是上,下,左,右,前,后,六个方向,每移动一次就耗费一分钟,要求输出最快的走出时间.不同L层的地图,相同RC坐标处是相连通的.(.可走,#为墙) 解题思路:从起点开始分别往6个方向进行BFS(即入队),并记录步数,直至队为空.若一直找不到,则困住. /* POJ 2251 Dungeon Master --- 三维BFS(用BFS求最短路) */ #include <cstdio> #i

三维bfs(HUD1253胜利大逃亡)

#include <stdio.h>#include <string.h>int map[51][51][51];int v[51][51][51];int a,b,c,t11;struct node{ int x,y,z,ans;}q[200001];int jx[6]={0,0,0,0,-1,1};int jy[6]={0,0,1,-1,0,0};int jz[6]={1,-1,0,0,0,0};void bfs(){ memset(v,0,sizeof(v)); struct